module pfcoef_sqrt_class
  use pfcoef_param_class
  implicit none
  private
  public :: get_pfcoef_sqrt
  real(DP), save :: minimaxerror(nkey)
  real(DP), save :: alp(nkey,0:npmax)
  real(DP), save :: bet(nkey,1:npmax)
  logical,  save :: m_is_initialized = .false.

contains

subroutine get_pfcoef_sqrt(this,m,mpow)
  implicit none
  type(partial_fraction_coef), intent(inout) :: this
  integer, intent(in) :: m
  integer, intent(in) :: mpow
  integer :: ikey
  call new_pfcoef_sqrt()
  if (allocated(this%alp)) deallocate(this%alp)
  if (allocated(this%bet)) deallocate(this%bet)
  allocate(this%alp(0:m))
  allocate(this%bet(1:m))
  ikey = mpow + (m-npmin)*npowmax
  this%npow = mpow
  this%n    = m
  this%minimaxerror = minimaxerror(ikey)
  this%alp(0:m) = alp(ikey,0:m)
  this%bet(1:m) = bet(ikey,1:m)
  return
end subroutine

subroutine new_pfcoef_sqrt()
  implicit none
  integer :: ikey,np,npow
  if (m_is_initialized) return
#include "PFcoef_SqrRootN04E01.dat"
#include "PFcoef_SqrRootN04E02.dat"
#include "PFcoef_SqrRootN04E03.dat"
#include "PFcoef_SqrRootN04E04.dat"
#include "PFcoef_SqrRootN04E05.dat"
#include "PFcoef_SqrRootN04E06.dat"
#include "PFcoef_SqrRootN04E07.dat"
#include "PFcoef_SqrRootN04E08.dat"
#include "PFcoef_SqrRootN05E01.dat"
#include "PFcoef_SqrRootN05E02.dat"
#include "PFcoef_SqrRootN05E03.dat"
#include "PFcoef_SqrRootN05E04.dat"
#include "PFcoef_SqrRootN05E05.dat"
#include "PFcoef_SqrRootN05E06.dat"
#include "PFcoef_SqrRootN05E07.dat"
#include "PFcoef_SqrRootN05E08.dat"
#include "PFcoef_SqrRootN06E01.dat"
#include "PFcoef_SqrRootN06E02.dat"
#include "PFcoef_SqrRootN06E03.dat"
#include "PFcoef_SqrRootN06E04.dat"
#include "PFcoef_SqrRootN06E05.dat"
#include "PFcoef_SqrRootN06E06.dat"
#include "PFcoef_SqrRootN06E07.dat"
#include "PFcoef_SqrRootN06E08.dat"
#include "PFcoef_SqrRootN07E01.dat"
#include "PFcoef_SqrRootN07E02.dat"
#include "PFcoef_SqrRootN07E03.dat"
#include "PFcoef_SqrRootN07E04.dat"
#include "PFcoef_SqrRootN07E05.dat"
#include "PFcoef_SqrRootN07E06.dat"
#include "PFcoef_SqrRootN07E07.dat"
#include "PFcoef_SqrRootN07E08.dat"
#include "PFcoef_SqrRootN08E01.dat"
#include "PFcoef_SqrRootN08E02.dat"
#include "PFcoef_SqrRootN08E03.dat"
#include "PFcoef_SqrRootN08E04.dat"
#include "PFcoef_SqrRootN08E05.dat"
#include "PFcoef_SqrRootN08E06.dat"
#include "PFcoef_SqrRootN08E07.dat"
#include "PFcoef_SqrRootN08E08.dat"
#include "PFcoef_SqrRootN09E01.dat"
#include "PFcoef_SqrRootN09E02.dat"
#include "PFcoef_SqrRootN09E03.dat"
#include "PFcoef_SqrRootN09E04.dat"
#include "PFcoef_SqrRootN09E05.dat"
#include "PFcoef_SqrRootN09E06.dat"
#include "PFcoef_SqrRootN09E07.dat"
#include "PFcoef_SqrRootN09E08.dat"
#include "PFcoef_SqrRootN10E01.dat"
#include "PFcoef_SqrRootN10E02.dat"
#include "PFcoef_SqrRootN10E03.dat"
#include "PFcoef_SqrRootN10E04.dat"
#include "PFcoef_SqrRootN10E05.dat"
#include "PFcoef_SqrRootN10E06.dat"
#include "PFcoef_SqrRootN10E07.dat"
#include "PFcoef_SqrRootN10E08.dat"
#include "PFcoef_SqrRootN11E01.dat"
#include "PFcoef_SqrRootN11E02.dat"
#include "PFcoef_SqrRootN11E03.dat"
#include "PFcoef_SqrRootN11E04.dat"
#include "PFcoef_SqrRootN11E05.dat"
#include "PFcoef_SqrRootN11E06.dat"
#include "PFcoef_SqrRootN11E07.dat"
#include "PFcoef_SqrRootN11E08.dat"
#include "PFcoef_SqrRootN12E01.dat"
#include "PFcoef_SqrRootN12E02.dat"
#include "PFcoef_SqrRootN12E03.dat"
#include "PFcoef_SqrRootN12E04.dat"
#include "PFcoef_SqrRootN12E05.dat"
#include "PFcoef_SqrRootN12E06.dat"
#include "PFcoef_SqrRootN12E07.dat"
#include "PFcoef_SqrRootN12E08.dat"
#include "PFcoef_SqrRootN13E01.dat"
#include "PFcoef_SqrRootN13E02.dat"
#include "PFcoef_SqrRootN13E03.dat"
#include "PFcoef_SqrRootN13E04.dat"
#include "PFcoef_SqrRootN13E05.dat"
#include "PFcoef_SqrRootN13E06.dat"
#include "PFcoef_SqrRootN13E07.dat"
#include "PFcoef_SqrRootN13E08.dat"
#include "PFcoef_SqrRootN14E01.dat"
#include "PFcoef_SqrRootN14E02.dat"
#include "PFcoef_SqrRootN14E03.dat"
#include "PFcoef_SqrRootN14E04.dat"
#include "PFcoef_SqrRootN14E05.dat"
#include "PFcoef_SqrRootN14E06.dat"
#include "PFcoef_SqrRootN14E07.dat"
#include "PFcoef_SqrRootN14E08.dat"
#include "PFcoef_SqrRootN15E01.dat"
#include "PFcoef_SqrRootN15E02.dat"
#include "PFcoef_SqrRootN15E03.dat"
#include "PFcoef_SqrRootN15E04.dat"
#include "PFcoef_SqrRootN15E05.dat"
#include "PFcoef_SqrRootN15E06.dat"
#include "PFcoef_SqrRootN15E07.dat"
#include "PFcoef_SqrRootN15E08.dat"
#include "PFcoef_SqrRootN16E01.dat"
#include "PFcoef_SqrRootN16E02.dat"
#include "PFcoef_SqrRootN16E03.dat"
#include "PFcoef_SqrRootN16E04.dat"
#include "PFcoef_SqrRootN16E05.dat"
#include "PFcoef_SqrRootN16E06.dat"
#include "PFcoef_SqrRootN16E07.dat"
#include "PFcoef_SqrRootN16E08.dat"
#include "PFcoef_SqrRootN17E01.dat"
#include "PFcoef_SqrRootN17E02.dat"
#include "PFcoef_SqrRootN17E03.dat"
#include "PFcoef_SqrRootN17E04.dat"
#include "PFcoef_SqrRootN17E05.dat"
#include "PFcoef_SqrRootN17E06.dat"
#include "PFcoef_SqrRootN17E07.dat"
#include "PFcoef_SqrRootN17E08.dat"
#include "PFcoef_SqrRootN18E01.dat"
#include "PFcoef_SqrRootN18E02.dat"
#include "PFcoef_SqrRootN18E03.dat"
#include "PFcoef_SqrRootN18E04.dat"
#include "PFcoef_SqrRootN18E05.dat"
#include "PFcoef_SqrRootN18E06.dat"
#include "PFcoef_SqrRootN18E07.dat"
#include "PFcoef_SqrRootN18E08.dat"
#include "PFcoef_SqrRootN19E01.dat"
#include "PFcoef_SqrRootN19E02.dat"
#include "PFcoef_SqrRootN19E03.dat"
#include "PFcoef_SqrRootN19E04.dat"
#include "PFcoef_SqrRootN19E05.dat"
#include "PFcoef_SqrRootN19E06.dat"
#include "PFcoef_SqrRootN19E07.dat"
#include "PFcoef_SqrRootN19E08.dat"
#include "PFcoef_SqrRootN20E01.dat"
#include "PFcoef_SqrRootN20E02.dat"
#include "PFcoef_SqrRootN20E03.dat"
#include "PFcoef_SqrRootN20E04.dat"
#include "PFcoef_SqrRootN20E05.dat"
#include "PFcoef_SqrRootN20E06.dat"
#include "PFcoef_SqrRootN20E07.dat"
#include "PFcoef_SqrRootN20E08.dat"
#include "PFcoef_SqrRootN21E01.dat"
#include "PFcoef_SqrRootN21E02.dat"
#include "PFcoef_SqrRootN21E03.dat"
#include "PFcoef_SqrRootN21E04.dat"
#include "PFcoef_SqrRootN21E05.dat"
#include "PFcoef_SqrRootN21E06.dat"
#include "PFcoef_SqrRootN21E07.dat"
#include "PFcoef_SqrRootN21E08.dat"
#include "PFcoef_SqrRootN22E01.dat"
#include "PFcoef_SqrRootN22E02.dat"
#include "PFcoef_SqrRootN22E03.dat"
#include "PFcoef_SqrRootN22E04.dat"
#include "PFcoef_SqrRootN22E05.dat"
#include "PFcoef_SqrRootN22E06.dat"
#include "PFcoef_SqrRootN22E07.dat"
#include "PFcoef_SqrRootN22E08.dat"
#include "PFcoef_SqrRootN23E01.dat"
#include "PFcoef_SqrRootN23E02.dat"
#include "PFcoef_SqrRootN23E03.dat"
#include "PFcoef_SqrRootN23E04.dat"
#include "PFcoef_SqrRootN23E05.dat"
#include "PFcoef_SqrRootN23E06.dat"
#include "PFcoef_SqrRootN23E07.dat"
#include "PFcoef_SqrRootN23E08.dat"
#include "PFcoef_SqrRootN24E01.dat"
#include "PFcoef_SqrRootN24E02.dat"
#include "PFcoef_SqrRootN24E03.dat"
#include "PFcoef_SqrRootN24E04.dat"
#include "PFcoef_SqrRootN24E05.dat"
#include "PFcoef_SqrRootN24E06.dat"
#include "PFcoef_SqrRootN24E07.dat"
#include "PFcoef_SqrRootN24E08.dat"
#include "PFcoef_SqrRootN25E01.dat"
#include "PFcoef_SqrRootN25E02.dat"
#include "PFcoef_SqrRootN25E03.dat"
#include "PFcoef_SqrRootN25E04.dat"
#include "PFcoef_SqrRootN25E05.dat"
#include "PFcoef_SqrRootN25E06.dat"
#include "PFcoef_SqrRootN25E07.dat"
#include "PFcoef_SqrRootN25E08.dat"
#include "PFcoef_SqrRootN26E01.dat"
#include "PFcoef_SqrRootN26E02.dat"
#include "PFcoef_SqrRootN26E03.dat"
#include "PFcoef_SqrRootN26E04.dat"
#include "PFcoef_SqrRootN26E05.dat"
#include "PFcoef_SqrRootN26E06.dat"
#include "PFcoef_SqrRootN26E07.dat"
#include "PFcoef_SqrRootN26E08.dat"
#include "PFcoef_SqrRootN27E01.dat"
#include "PFcoef_SqrRootN27E02.dat"
#include "PFcoef_SqrRootN27E03.dat"
#include "PFcoef_SqrRootN27E04.dat"
#include "PFcoef_SqrRootN27E05.dat"
#include "PFcoef_SqrRootN27E06.dat"
#include "PFcoef_SqrRootN27E07.dat"
#include "PFcoef_SqrRootN27E08.dat"
#include "PFcoef_SqrRootN28E01.dat"
#include "PFcoef_SqrRootN28E02.dat"
#include "PFcoef_SqrRootN28E03.dat"
#include "PFcoef_SqrRootN28E04.dat"
#include "PFcoef_SqrRootN28E05.dat"
#include "PFcoef_SqrRootN28E06.dat"
#include "PFcoef_SqrRootN28E07.dat"
#include "PFcoef_SqrRootN28E08.dat"
#include "PFcoef_SqrRootN29E01.dat"
#include "PFcoef_SqrRootN29E02.dat"
#include "PFcoef_SqrRootN29E03.dat"
#include "PFcoef_SqrRootN29E04.dat"
#include "PFcoef_SqrRootN29E05.dat"
#include "PFcoef_SqrRootN29E06.dat"
#include "PFcoef_SqrRootN29E07.dat"
#include "PFcoef_SqrRootN29E08.dat"
#include "PFcoef_SqrRootN30E01.dat"
#include "PFcoef_SqrRootN30E02.dat"
#include "PFcoef_SqrRootN30E03.dat"
#include "PFcoef_SqrRootN30E04.dat"
#include "PFcoef_SqrRootN30E05.dat"
#include "PFcoef_SqrRootN30E06.dat"
#include "PFcoef_SqrRootN30E07.dat"
#include "PFcoef_SqrRootN30E08.dat"
#include "PFcoef_SqrRootN31E01.dat"
#include "PFcoef_SqrRootN31E02.dat"
#include "PFcoef_SqrRootN31E03.dat"
#include "PFcoef_SqrRootN31E04.dat"
#include "PFcoef_SqrRootN31E05.dat"
#include "PFcoef_SqrRootN31E06.dat"
#include "PFcoef_SqrRootN31E07.dat"
#include "PFcoef_SqrRootN31E08.dat"
#include "PFcoef_SqrRootN32E01.dat"
#include "PFcoef_SqrRootN32E02.dat"
#include "PFcoef_SqrRootN32E03.dat"
#include "PFcoef_SqrRootN32E04.dat"
#include "PFcoef_SqrRootN32E05.dat"
#include "PFcoef_SqrRootN32E06.dat"
#include "PFcoef_SqrRootN32E07.dat"
#include "PFcoef_SqrRootN32E08.dat"
  m_is_initialized = .true.
  return
end subroutine

end module
